# -*- coding:utf-8 -*-
import sys
from configobj import ConfigObj

class ConfigError(Exception):
    pass

#loglevel = 'DEBUG'
loglevel = 'INFO'
logfile = "/var/lib/eole/reports/importaaf.log"
conffile = "/etc/aaf.conf"
try:
    config = ConfigObj(conffile)
except Exception as e:
    print("ERROR: --- unable to load configuration file : {0} ---".format(conffile))
    sys.exit(1)

file_format = config['file_format']

# XML paths
path_aaf_complet = config.get('path_aaf_complet', "/home/aaf-complet")
path_aaf_delta = config.get('path_aaf_delta', "/home/aaf-delta")
# LDIF paths
template_path = "/var/lib/eole/aaf"
ldif_path = config.get('ldif_path', '/home')

# reports filename
aaf_exceptions_report_filename = config.get('aaf_exceptions_report_filename', "/var/log/eole/aafexceptions.log")

# name of the autoritary source
autoritary_source = config.get('autoritary_source', 'AC-ACAD')
# letter of the ENT project code
ent_letter = config.get('ent_letter', 'A')
# number of the ENT project code
ent_number = config.get('ent_number', '1')

# SQL configuration
dbfilename = config.get('dbfilename', '/var/lib/sqlite/eoleaaf.sql')
dbname = config.get('dbname', 'eoleaaf')
dbuser = config.get('dbuser', 'eoleaaf')
dbpasswd = config.get('dbpasswd', 'eoleaaf')

# samba configuration
smbstructure = config.get('smbstructure', 'toplevel') # toplevel, split
rootdnpasswd = config.get('rootdnpasswd', 'rootpwd')
basedn = config.get('basedn', 'DC=ac-test,DC=fr')
structsdn = "ou=structures,{0}".format(basedn)
groupsdn = "ou=groupes,{0}".format(basedn)
appsdn = "ou=applications,{0}".format(basedn)

loginshell = config.get('loginshell', None)
homedrive = config.get('homedrive', None)
profile_type = config.get('profile_type', 'none')  # valeur possible : none, itinerant ou local
domainnames = config.get('domainname', {})
commonnames = config.get('commonname', {})

# ldap delta filenames
ldap_delta_create_filename = "delta_create.ldif"
ldap_delta_update_filename = "delta_update.ldif"
ldap_delta_delete_filename = "delta_delete.ldif"

# multi-values separator
multisep = "\n"

# types de structures à ventiler dans la catégorie "ENTServAc"
entservac_structures = ('RECTORAT',
                        'VICE RECTORAT TOM',
                        'DIRECTION SERVICES DEPARTEMENTAUX EN',
                        'SERVICE DE LA DSDEN')

generic_groups = {'eleves': 'j', 'professeurs': 'k', 'administratifs': 'l'}
nb_generic_groups = len(generic_groups)

toplevel_ou_user = config.get('toplevel_ou_user', "CN=Users")
toplevel_ou_group = config.get('toplevel_ou_group', toplevel_ou_user)
etabnumber = config['etabnumber']
nom_domaine_machine = config['nom_domaine_machine']
if config.get('remove_first_username_idx') == 'True':
    remove_first_username_idx = True
else:
    remove_first_username_idx = False
