# -*- coding: utf-8 -*-
###########################################################################
# Eole NG - 2013
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
###########################################################################
"""
miscellaneous utilities
"""
import sys
from eoleaaf.util import get_new_id, pwgen, modif_fields
from logging import getLogger
aaflog = getLogger("AAF")
#_______________________________________________________________________________
# XML parsing utilities

def parse_xml_files(aaftype,
                    aaffunc,
                    xml_files,
                    lib,
                    aaffunc_delete,
                    allow_bulk,
                    ):
    """
    Appel à la fonction de traitement du XML
    en fonction du type de fichier

    :param aaftypes: mapping nom de fichier/méthode à appeler
    :param xml_files: liste des fichiers à traiter
    :param lib: module aaf ou aafdelta
    :return: list of all the parsed ids
    """
    aaftype_ids = []
    aaflog.info("Traitement des fichiers {0}".format(aaftype))
    typed_xml_files = [ fname for fname in xml_files if aaftype in fname]
    total = 0
    for fname in typed_xml_files:
        aaflog.info("\nLecture du fichier {0}".format(fname))
        subtotal, aaftypeids = getattr(lib, aaffunc)(fname, allow_bulk)
        if subtotal:
            total += subtotal
        if aaffunc_delete is not None:
            aaftype_ids.extend(aaftypeids)
    if total:
        aaflog.info("TOTAL : {}".format(total))
    if aaffunc_delete is not None:
        # we delete the entities that are not present in the database anymore
        getattr(lib, aaffunc_delete)(aaftype_ids)


def user_id(tdata):
    """finds the id in the XML and formates it

    :param tdate: xml etree object
    :returns: data dictionnary
    """
    tid = tdata.find('identifier/id').text
    if sys.version_info[0] < 3:
        return {'id': unicode(tid)}
    else:
        return {'id': str(tid)}
